#include <iostream>
#include <cstdlib>
#include <string>
#include <iomanip>
#include <ctime>

using namespace std;

void menu();
double diameter_to_radius(double diameter);
double random_value_generator(double min, double max);
double area(double radius);
double circumference(double radius);

const double PI = 3.14159;

int main() {
  int option;
  string unit;
  double radius, diameter, value;
  string choice;
  srand(time(NULL));

  while (true) {
    // prompt the user for the radius or diameter
    menu();
    while (true) {
      cin >> option;
      if (option != 1 && option != 2 && option != -1) {
        cout << "Invalid choice, please try again." << endl;
        cout << "Enter an option: ";
      } else {
        break;
      }
    }
    if (option == -1) {
      break;
    }

    // prompt the user for the unit
    cout << "Is your unit cm or m ?" << endl;
    while (true) {
      cin >> unit;
      if (unit != "cm" && unit != "m") {
        cout << "Wrong unit, given either cm or m " << endl;
      } else {
        break;
      }
    }

    // generate the random value and translate into radius
    if (option == 1) {
      radius = random_value_generator(5.0, 15.0);
      cout << "The radius given by random generator is: "
           << setprecision(2) << fixed << radius << " " << unit << endl;
    } else {
      diameter = random_value_generator(15.0, 30.0);
      cout << "The diameter given by random generator is: "
           << setprecision(2) << fixed << diameter << " " << unit << endl;
      radius = diameter_to_radius(diameter);
      cout << "The corresponding radius is: "
           << setprecision(2) << fixed << radius << " " << unit << endl;
    }
    cout << endl;

    // prompt the user to calculate either area or circumference
    cout << "Do you want to calculate area or circumference?" << endl
         << "Enter 'A' for area and 'C' for circumference" << endl;
    while (true) {
      cin >> choice;
      if (choice != "A" && choice != "C") {
        cout << "Wrong chice, re-enter the choice" << endl;
      } else if (choice == "A") { // calculate area
        value = area(radius);
        cout << "The area of the circle with ";
        if (option == 1) {
          cout << "radius " << setprecision(2) << fixed << radius;
        } else {
          cout << "diameter " << setprecision(2) << fixed << diameter;
        }
        cout << " is "<< setprecision(2) << fixed << value << " "
             << unit << "2" << endl;
        break;
      } else if (choice == "C") { // calculate circumference
        value = circumference(radius);
        cout << "Thea circumference of the circle with ";
        if (option == 1) {
          cout << "radius " << setprecision(2) << fixed << radius;
        } else {
          cout << "diameter " << setprecision(2) << fixed << diameter;
        }
        cout << " is "<< setprecision(2) << fixed << value << " "
             << unit << endl;
        break;
      }
    }
    cout << endl << endl;
  }

  return 0;
}

// display the menu
void menu() {
  cout << "Do you want to use radius or diameter for the calculation?" << endl
       << "Enter 1 for radius" << endl
       << "Enter 2 for diameter" << endl
       << "Enter -1 to exit" << endl;
}

// calculate the radius from the given diameter
double diameter_to_radius(double diameter) {
  return diameter / 2;
}

// generate a random double between minimum and maximum
double random_value_generator(double min, double max) {
  double ratio = (double)rand() / RAND_MAX;
  return min + ratio * (max - min);
}

// calculate the area of the circle with the given radius
double area(double radius) {
  return PI * radius * radius;
}

// calculate the circumference of the circle with the given radius
double circumference(double radius) {
  return 2 * PI * radius;
}
