#include <iostream>
#include <iomanip>

using namespace std;

int digit(int width);
int shape(int width, int row);

int main() {
  // prompt the user to enter the shape width
  int width;
  cout << "Width of the shape? (Enter odd number only) ";
  cin >> width;
  if (width < 0 || width % 2 != 1) {
    cout << "Invalid width" << endl;
    return -1;
  }

  // prompt the user to enter the row
  int row;
  cout << "Enter row number to get sum ";
  cin >> row;
  if (row < 1 || row > width) {
    cout << "Invalid row" << endl;
    return -1;
  }
  cout << endl << endl;

  // the width and row is valid, display the shape
  // and calculate sum of row
  int sum = shape(width, row);
  cout << "\n\nSum of row " << row << " is " << sum << endl;

  return 0;
}

// calculate how many digit is needed to print the width
int digit(int width) {
  int digit = 1;
  while (width >= 10) {
    digit ++;
    width /= 10;
  }
  return digit;
}

int shape(int width, int row) {
  int result = 0;
  int w = digit(width);
  int center = width / 2 * (w + 1);

  // upper half
  for (int i = 0; i <= width / 2; i++) {
    int sum = 0;
    cout << setw(center - i * (w + 1)) << "";
    for (int j = 1; j <= 2 * i + 1; j++) {
      cout << setw(w + 1) << right << j;
      sum += j;
    }
    cout << endl;
    row --;
    if (row == 0) { // find the target row
      result = sum;
    }
  }

  // lower half
  for (int i = width / 2 - 1; i >= 0; i--) {
    int sum = 0;
    cout << setw(center - i * (w + 1)) << "";
    for (int j = 1; j <= 2 * i + 1; j++) {
      cout << setw(w + 1) << right << j;
      sum += j;
    }
    cout << endl;
    row --;
    if (row == 0) { // find the target row
      result = sum;
    }
  }

  return result;
}
