#ifndef TYPE_H
#define TYPE_H

#include <stdio.h>

struct elem {
  char arr[256];
  int v1;
  float v2;
};

/* the node of the stack or linked list */
struct node {
  struct elem e;
  struct node *next;
};

/* the stack structure */
struct stack {
  struct node *top;
};

/* the linked list structure */
struct linkedlist {
  struct node *head;
};

/* display the element to the output file */
void display_elem(FILE *out, struct elem *e);

/* two sorting functions: bit to specify to sort using
 * int value or float value. flag to specify ascending or descending */
void insertion_sort(struct elem v[], int n, int bit, int flag);
void selection_sort(struct elem v[], int n, int bit, int flag);
void reverse(struct elem v[], int n);

/* two search functions */
void linear_search(struct elem v[], int n, int value);
void binary_search(struct elem v[], int n, int value);

/* list functions */
void insert_linkedlist(struct linkedlist *l, struct elem e);
void display_linkedlist(FILE *out, struct linkedlist *l);

/* stack functions */
void push_stack(struct stack *s, struct elem e);
void linear_search_stack_1(struct stack *s, char *value);
void linear_search_stack_2(struct stack *s, int value);
void save_stack(FILE *out, struct stack *s);

#endif
